OpenShot Audio Library | OpenShotAudio: juce::FloatVectorOperationsBase< FloatType, CountType > Struct Template Reference

OpenShot Audio Library | OpenShotAudio 0.4.0

Loading...
Searching...
No Matches
Static Public Member Functions | List of all members
juce::FloatVectorOperationsBase< FloatType, CountType > Struct Template Reference

`#include <juce_FloatVectorOperations.h>`

## Static Public Member Functions
static void JUCE_CALLTYPE | clear (FloatType *dest, CountType numValues) noexcept
static void JUCE_CALLTYPE | fill (FloatType *dest, FloatType valueToFill, CountType numValues) noexcept
static void JUCE_CALLTYPE | copy (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | copyWithMultiply (FloatType *dest, const FloatType *src, FloatType multiplier, CountType numValues) noexcept
static void JUCE_CALLTYPE | add (FloatType *dest, FloatType amountToAdd, CountType numValues) noexcept
static void JUCE_CALLTYPE | add (FloatType *dest, const FloatType *src, FloatType amount, CountType numValues) noexcept
static void JUCE_CALLTYPE | add (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | add (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | subtract (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | subtract (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | addWithMultiply (FloatType *dest, const FloatType *src, FloatType multiplier, CountType numValues) noexcept
static void JUCE_CALLTYPE | addWithMultiply (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | subtractWithMultiply (FloatType *dest, const FloatType *src, FloatType multiplier, CountType numValues) noexcept
static void JUCE_CALLTYPE | subtractWithMultiply (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | multiply (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | multiply (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType numValues) noexcept
static void JUCE_CALLTYPE | multiply (FloatType *dest, FloatType multiplier, CountType numValues) noexcept
static void JUCE_CALLTYPE | multiply (FloatType *dest, const FloatType *src, FloatType multiplier, CountType num) noexcept
static void JUCE_CALLTYPE | negate (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | abs (FloatType *dest, const FloatType *src, CountType numValues) noexcept
static void JUCE_CALLTYPE | min (FloatType *dest, const FloatType *src, FloatType comp, CountType num) noexcept
static void JUCE_CALLTYPE | min (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | max (FloatType *dest, const FloatType *src, FloatType comp, CountType num) noexcept
static void JUCE_CALLTYPE | max (FloatType *dest, const FloatType *src1, const FloatType *src2, CountType num) noexcept
static void JUCE_CALLTYPE | clip (FloatType *dest, const FloatType *src, FloatType low, FloatType high, CountType num) noexcept
static Range< FloatType > JUCE_CALLTYPE | findMinAndMax (const FloatType *src, CountType numValues) noexcept
static FloatType JUCE_CALLTYPE | findMinimum (const FloatType *src, CountType numValues) noexcept
static FloatType JUCE_CALLTYPE | findMaximum (const FloatType *src, CountType numValues) noexcept

## Detailed Description

template<typename FloatType, typename CountType>
struct juce::FloatVectorOperationsBase< FloatType, CountType >

A collection of simple vector operations on arrays of floating point numbers, accelerated with SIMD instructions where possible, usually accessed from the FloatVectorOperations class.

float data[64];
// The following two function calls are equivalent:
FloatVectorOperationsBase<float, int>::clear (data, 64);
FloatVectorOperations::clear (data, 64);
juce::FloatVectorOperationsBase::clear
static void JUCE_CALLTYPE clear(FloatType *dest, CountType numValues) noexcept
Definition juce_FloatVectorOperations.cpp:1176

See also
  FloatVectorOperations

Definition at line 54 of file juce_FloatVectorOperations.h.

## Member Function Documentation

## ◆ abs()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::abs | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Copies a source vector to a destination, taking the absolute of each value.

Definition at line 1337 of file juce_FloatVectorOperations.cpp.

## ◆ add() [1/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::add | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Adds the source values to the destination values.

Definition at line 1225 of file juce_FloatVectorOperations.cpp.

## ◆ add() [2/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::add | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | amount,
|  | CountType | numValues )
| staticnoexcept

Adds a fixed value to each source value and stores it in the destination array.

Definition at line 1216 of file juce_FloatVectorOperations.cpp.

## ◆ add() [3/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::add | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Adds each source1 value to the corresponding source2 value and stores the result in the destination array.

Definition at line 1233 of file juce_FloatVectorOperations.cpp.

## ◆ add() [4/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::add | ( | FloatType * | dest,
|  | FloatType | amountToAdd,
|  | CountType | numValues )
| staticnoexcept

Adds a fixed value to the destination values.

Definition at line 1208 of file juce_FloatVectorOperations.cpp.

## ◆ addWithMultiply() [1/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::addWithMultiply | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | multiplier,
|  | CountType | numValues )
| staticnoexcept

Multiplies each source value by the given multiplier, then adds it to the destination value.

Definition at line 1259 of file juce_FloatVectorOperations.cpp.

## ◆ addWithMultiply() [2/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::addWithMultiply | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Multiplies each source1 value by the corresponding source2 value, then adds it to the destination value.

Definition at line 1268 of file juce_FloatVectorOperations.cpp.

## ◆ clear()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::clear | ( | FloatType * | dest,
|  | CountType | numValues )
| staticnoexcept

Clears a vector of floating point numbers.

Definition at line 1176 of file juce_FloatVectorOperations.cpp.

## ◆ clip()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::clip | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | low,
|  | FloatType | high,
|  | CountType | num )
| staticnoexcept

Each element of dest is calculated by hard clipping the corresponding src element so that it is in the range specified by the arguments low and high.

Definition at line 1381 of file juce_FloatVectorOperations.cpp.

## ◆ copy()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::copy | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Copies a vector of floating point numbers.

Definition at line 1191 of file juce_FloatVectorOperations.cpp.

## ◆ copyWithMultiply()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::copyWithMultiply | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | multiplier,
|  | CountType | numValues )
| staticnoexcept

Copies a vector of floating point numbers, multiplying each value by a given multiplier

Definition at line 1199 of file juce_FloatVectorOperations.cpp.

## ◆ fill()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::fill | ( | FloatType * | dest,
|  | FloatType | valueToFill,
|  | CountType | numValues )
| staticnoexcept

Copies a repeated value into a vector of floating point numbers.

Definition at line 1183 of file juce_FloatVectorOperations.cpp.

## ◆ findMaximum()

template<typename FloatType , typename CountType >

FloatType JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::findMaximum | ( | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Finds the maximum value in the given array.

Definition at line 1405 of file juce_FloatVectorOperations.cpp.

## ◆ findMinAndMax()

template<typename FloatType , typename CountType >

Range< FloatType > JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::findMinAndMax | ( | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Finds the minimum and maximum values in the given array.

Definition at line 1391 of file juce_FloatVectorOperations.cpp.

## ◆ findMinimum()

template<typename FloatType , typename CountType >

FloatType JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::findMinimum | ( | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Finds the minimum value in the given array.

Definition at line 1398 of file juce_FloatVectorOperations.cpp.

## ◆ max() [1/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::max | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | comp,
|  | CountType | num )
| staticnoexcept

Each element of dest will be the maximum of the corresponding element of the source array and the given comp value.

Definition at line 1363 of file juce_FloatVectorOperations.cpp.

## ◆ max() [2/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::max | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Each element of dest will be the maximum of the corresponding source1 and source2 values.

Definition at line 1372 of file juce_FloatVectorOperations.cpp.

## ◆ min() [1/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::min | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | comp,
|  | CountType | num )
| staticnoexcept

Each element of dest will be the minimum of the corresponding element of the source array and the given comp value.

Definition at line 1345 of file juce_FloatVectorOperations.cpp.

## ◆ min() [2/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::min | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Each element of dest will be the minimum of the corresponding source1 and source2 values.

Definition at line 1354 of file juce_FloatVectorOperations.cpp.

## ◆ multiply() [1/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::multiply | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Multiplies the destination values by the source values.

Definition at line 1295 of file juce_FloatVectorOperations.cpp.

## ◆ multiply() [2/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::multiply | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | multiplier,
|  | CountType | num )
| staticnoexcept

Multiplies each of the source values by a fixed multiplier and stores the result in the destination array.

Definition at line 1320 of file juce_FloatVectorOperations.cpp.

## ◆ multiply() [3/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::multiply | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | numValues )
| staticnoexcept

Multiplies each source1 value by the corresponding source2 value, then stores it in the destination array.

Definition at line 1303 of file juce_FloatVectorOperations.cpp.

## ◆ multiply() [4/4]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::multiply | ( | FloatType * | dest,
|  | FloatType | multiplier,
|  | CountType | numValues )
| staticnoexcept

Multiplies each of the destination values by a fixed multiplier.

Definition at line 1312 of file juce_FloatVectorOperations.cpp.

## ◆ negate()

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::negate | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Copies a source vector to a destination, negating each value.

Definition at line 1329 of file juce_FloatVectorOperations.cpp.

## ◆ subtract() [1/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::subtract | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | CountType | numValues )
| staticnoexcept

Subtracts the source values from the destination values.

Definition at line 1242 of file juce_FloatVectorOperations.cpp.

## ◆ subtract() [2/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::subtract | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Subtracts each source2 value from the corresponding source1 value and stores the result in the destination array.

Definition at line 1250 of file juce_FloatVectorOperations.cpp.

## ◆ subtractWithMultiply() [1/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::subtractWithMultiply | ( | FloatType * | dest,
|  | const FloatType * | src,
|  | FloatType | multiplier,
|  | CountType | numValues )
| staticnoexcept

Multiplies each source value by the given multiplier, then subtracts it to the destination value.

Definition at line 1277 of file juce_FloatVectorOperations.cpp.

## ◆ subtractWithMultiply() [2/2]

template<typename FloatType , typename CountType >

void JUCE_CALLTYPE juce::FloatVectorOperationsBase< FloatType, CountType >::subtractWithMultiply | ( | FloatType * | dest,
|  | const FloatType * | src1,
|  | const FloatType * | src2,
|  | CountType | num )
| staticnoexcept

Multiplies each source1 value by the corresponding source2 value, then subtracts it to the destination value.

Definition at line 1286 of file juce_FloatVectorOperations.cpp.

The documentation for this struct was generated from the following files:

- juce_FloatVectorOperations.h
- juce_FloatVectorOperations.cpp